Simple cron module
===============

## Requirements
 
 - PHP 7.2.0
 - [dragonmantank/cron-expression](https://packagist.org/packages/dragonmantank/cron-expression)

## Installation

To install this module, use `composer require` or place it in your modules
folder and enable it on the modules page.

## Single cron job run

Single cron job run works by adding cron job ID in default cron run url query parameter.
Use the "force" query parameter for cron run without checking crontab expresion.

Examples:
- https://localhost/cron/[system.cron_key]?job=job_id
- https://localhost/cron/[system.cron_key]?job=job_id&force=1

## Drush commands

Module provides two new drush commands:

 - drush simple-cron job_id
 - drush simple-cron:list
 
## Examples

This module allows developers to add custom cron jobs by providing a plugin.
New plugin type is provided: SimpleCron.
The Simple Cron Examples module (modules/extra_field_example) contains ready to use plugin examples.
You can copy an example over to your (custom) module and modify it to suit your needs.

## Site builder usage

Once created, the simple cron job can be configured in /admin/config/system/cron/jobs administration page.

All settings for this module are on the Simple Cron configuration page, under the
Configuration &rightarrow; System &rightarrow; Cron &rightarrow; Simple cron settings.

You can visit the configuration page directly at admin/config/system/cron/jobs/settings.

## Plugin

Plugin of type "SimpleCron" is used to provide simple cron jobs implementation.
Plugin examples can be found in the included simple_cron_example module.

SimpleCron plugins must be placed in: [module name]/src/Plugin/SimpleCron.
After creating a plugin, clear the cache to make Drupal recognise it.

SimpleCron plugins must at least extend the SimpleCronPluginInterface.

SimpleCron annotation should at least contain:
```
 * @SimpleCron(
 *   id = "plugin_id",
 *   label = @Translation("Job name"),
 * )
```

Other annotation options:
```
 *   weight = 0
```
